/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-angular-core";
import { Style } from "igniteui-angular-core";
import { markType, markDep, typeCast } from "igniteui-angular-core";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { ChartSelection } from "./ChartSelection";
import { List$1 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { Path } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterPolylineSeries = /*@__PURE__*/ (() => {
    class ScatterPolylineSeries extends ShapeSeriesBase {
        constructor() {
            super();
            this.ab = ScatterPolylineSeries.$;
        }
        bk() {
            return new ScatterPolylineSeries();
        }
        get_fs() {
            return true;
        }
        ct() {
            return new ScatterPolylineSeriesView(this);
        }
        get_ya() {
            return false;
        }
        q7(a) {
            super.q7(a);
            this.aah = a;
        }
        get_yg() {
            return false;
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case ScatterPolylineSeries.$$p[0]:
                    this.aah.db(this.aan);
                    this.ry(false);
                    this.qr();
                    break;
                case ScatterPolylineSeries.$$p[1]:
                    this.aah.dc(this.aai);
                    this.ry(false);
                    this.qr();
                    break;
            }
        }
        zx(a) {
            let b = a;
            b.db(this.aan);
            b.dc(this.aai);
            super.zx(a);
        }
        a2(a, b) {
            let c = this.aah.dg(a, b, true);
            if (c != null) {
                return c.dataContext;
            }
            return super.a2(a, b);
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.qa(a, c, b);
            return c.toArray();
        }
        qa(a, b, c) {
            this.zp(a, b, c);
        }
    }
    ScatterPolylineSeries.$t = markType(ScatterPolylineSeries, 'ScatterPolylineSeries', ShapeSeriesBase.$);
    ScatterPolylineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolylineSeries, 'raisePropertyChanged', ['ShapeStyle:aan:aal', [Style.$, null], 'ShapeStyleSelector:aai:aam', [StyleSelector.$, null]]);
    return ScatterPolylineSeries;
})();
/**
 * @hidden
 */
export let ScatterPolylineSeriesView = /*@__PURE__*/ (() => {
    class ScatterPolylineSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.cj.jt = Defaults.an;
            }
        }
        di(a, b) {
            return this.dj(a, b, false);
        }
        cz(a, b, c) {
            super.cz(a, b, c);
            ShapeSeriesViewBase.cy(this, a, b);
        }
        cx(a, b) {
            let c = typeCast(Path.$, a);
            if (c == null) {
                return;
            }
            c.an = b;
        }
        ak(a) {
            let b = super.ak(a);
            b._fill = null;
            return b;
        }
        aj(a) {
            let b = super.aj(a);
            b._fill = null;
            return b;
        }
        co(a) {
            return a.width >= this.cj.yx || a.height >= this.cj.yx;
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.f.ba.a$u(this.f);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cj.title + "</span><br/>";
            a += "</div>";
            return a;
        }
    }
    ScatterPolylineSeriesView.$t = markType(ScatterPolylineSeriesView, 'ScatterPolylineSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolylineSeriesView;
})();
